(function(){

	var callbacks = {};
	var counter = 1;
	var NativeAPI = window.NativeInterface;
	//调用java方法
	var send = function(message,tag){
		if(tag == "title"){
			NativeAPI.invokeTitle(message);
			return;
		}
		var message = JSON.stringify(message);
		//console.log("send method start------" + message);
		if(tag == "origin"){
			NativeAPI.invokeNative(message);
		}else if(tag == "back"){
			NativeAPI.invokeBack(message);
		}
		
	};
	//处理回调
	var handleCallback = function(message){
		//console.log("handleCallback method start");
		//console.log(message);
		var reslut = JSON.parse(message);
		var error = "", res = "";
		//报错信息
		if(reslut.code == -1){
			error = reslut.message;
			//console.log("reslut.message-----"+error);
		}
		//成功信息
		if(reslut.code == 0){
			res = reslut.data;
			//console.log(reslut.callbackId+"---"+res);
		}
		var callback = callbacks[reslut.callbackId];
		if(!callback){
			return;
		}
		callbacks[message.id] = null;

		setTimeout(function(){
			//console.log("setTimeout start");

			callback(error,res);
		},0);

	};


	//js 调用java 前的数据处理
	var invoke = function(method,params,callback,tag){
		//console.log("invoke method start" + "--"+ method);
		if(method=="title"){
			send(params,"title");
			return;
		}
	 	var message = {
	 		ruleName:method,
	 		data:params
	 	}
	 	if(tag == "init"){
	 		callbacks.back = callback;
	 		return;
	 	}
	 	if(callback){
	 		counter = counter + 1;
	 		callbackId = "jsonc_" + counter;
	 		message.callbackId = callbackId;
	 		callbacks[callbackId] = callback;
	 	}
	 	if(tag == "back"){
	 		tag = "back";
	 	}
	 	if(!tag){
	 		tag = "origin";
	 	}
	 	send(message,tag);
	 	
	 };

	 var handleErrorMessage = function(element){
	 	errorDom = element;
	 };

	 window.handleCallback = handleCallback;
	 window.invoke  = invoke;

})(window);

