var NativeAPI = window.NativeInterface;
var PHONE_GLOBAL = {
	TIME_COUNT:120,
	CODE_TIMER:null
};
var phoneCodeTimer,phoneCodeText,phoneCodeText2,phoneMessage,handleBackTag=0,phoneAccount,phoneCodeWrap;

var phoneTab,emailTab,guide,guideLine,submitArea,submitButton;
var phoneButtonValue = "", phoneZone = true;

//填写手机短信验证码时的返回倒计时
function timer(){
	if(PHONE_GLOBAL.TIME_COUNT>0){
		phoneCodeText2.style.display = "none";
		phoneCodeText.style.display = "block";
		phoneMessage.className = "phone-code-input";
		PHONE_GLOBAL.TIME_COUNT = PHONE_GLOBAL.TIME_COUNT - 1;
		phoneCodeTimer.innerHTML = PHONE_GLOBAL.TIME_COUNT;
	}else{
		clearInterval(PHONE_GLOBAL.CODE_TIMER);
		phoneMessage.className = "phone-code-input phone-code-input-spe";
		phoneCodeText.innerHTML = "一天只能获取三次验证码";
		phoneCodeText.style.display = "none";
		phoneCodeText2.style.display = "block";
		PHONE_GLOBAL.TIME_COUNT = 120;
	}
}

//显示手机密码找回区
function showPhone(){
	for(var j = 0; j<guide.length; j++){
		guide[j].className = "guide-title";
	}
	guide[0].className = "guide-title guide-title-choose";
	guideLine.className = "guide-line guide-line-left";
	phoneTab.style.display = "block";
	emailTab.style.display = "none";
	phoneZone = true;
	submitArea.style.display = "block";
	submitButton.id = phoneButtonValue?phoneButtonValue:"account";//设置提交按钮
	if(handleBackTag == 1){
		handleBack(1,phoneAccount,phoneCodeWrap);
	}
}

//显示邮箱密码找回区
function showEmail(){
	for(var j = 0; j<guide.length; j++){
		guide[j].className = "guide-title";
	}
	guide[1].className = "guide-title guide-title-choose";
	guideLine.className = "guide-line guide-line-right";
	phoneTab.style.display = "none";
	emailTab.style.display = "block";
	phoneZone = false;
	submitArea.style.display = "block";
	submitButton.id = "email";//设置提交按钮
	handleBack(0);

}

//显示错误信息
function showError(error,errorDialog){
	errorDialog.innerHTML = "错误提示：" + error;
	errorDialog.style.display = "block";
}

//获取验证码
//@parmas:element 获取验证码的文档节点 
function getCode(element){
	NativeAPI.invokeProgressDialog("请稍候");
	invoke("forget_password_captcha"
		,{
			method:'resetPassword',
		}
		,function(error,res){
			NativeAPI.invokeProgressDialogDismiss();
			if(error){
				showError(error,errorDialog);
				return;
			}
			element.src =  "data:image/png;base64," +res.image;
	});

}
//处理用户点击返回按钮
function handleBack(tag,pre,current){
	invoke("",{},function(){
		var a = submitButton.id;
		invoke("invokeBack",{backCode:tag},function(){},"back");
		if(pre&&current){
			pre.style.display = "block";
			current.style.display = "none";
			submitButton.id = "account";
			handleBackTag = 1;
		}
		
	},"init");
}
window.onload = function(){

	var phoneNumber = common.getClass("phone-number"),//手机号码区
	phoneIdNumber = common.getClass("phone-id-number"),//手机证件号码区
	phoneCodeImg = common.getClass("phone-code-img"),//手机区验证码图片
	emailNumber = common.getClass("email-number"),//邮箱号区
	emailIdNumber = common.getClass("email-id-number"),//邮箱证件号码区
	emailCodeImg = common.getClass("email-code-img"),//邮箱区验证码图片

	errorDialog = common.getClass("error-dialog"),//错误提示区
	phoneValue = "",//手机号码
	phoneIdcardType = "1",//手机证件类型
	phoneIdcardValue = "",//手机证件号码
	
	emailValue = "",//邮箱号码
	emailIdcardType = "1",//邮箱证件类型
	emailIdcardValue = "",//邮箱证件号码
	phoneInputCode = common.getClass("phone-code"),//手机区验证码
	emailInputCode = common.getClass("email-code"),//邮箱区验证码
	emailCodeValue = "",//邮箱验证码值
	phoneCodeValue = "";//手机验证码值

	phoneMessage = common.getClass("phone-code-input");//手机短信验证码区

	submitButton = common.getClass("submit-button");//获取提交按钮

	//设置activity名称头
	invoke("title","手机找回",function(){});
	//初始化找回密码区
	//invoke("jsInitforgetMyPassword",{},function(error,res){
	//	if(error){
	//		showError(error,errorDialog);
	//		return;
	//	}
	//
	//});

	getCode(phoneCodeImg);//获取手机区的验证码

	

	
	//操作找回方式转换
	phoneCodeTimer = common.getClass("phone-code-seconds");
	phoneCodeText = common.getClass("phone-code-text");
	phoneCodeText2 = common.getClass("phone-code-text2");
	phoneTab = common.getClass("phone-tab"),
	emailTab = common.getClass("email-tab"),
	guide = common.getClasses("guide-title"),//
	guideLine = common.getClass("guide-line");

	submitArea = common.getClass("submit-area");//获取提交区
	
	guide[0].addEventListener("click",function(e){
		showPhone();
		invoke("title","手机找回",function(){});
		phoneInputCode.value = "";
		phoneCodeValue = "";
		getCode(phoneCodeImg);
	});
	guide[1].addEventListener("click",function(e){
		showEmail();
		invoke("title","邮箱找回",function(){});
		emailCodeValue = "";
		emailInputCode.value = "";
		getCode(emailCodeImg);
	});

	var container = common.getClass("container");
	
	container.addEventListener("click",function(e){
		// console.log(e);
		// console.log(e.target.parentNode.className);
		//console.log(this);
		//隐藏错误提示
		if(e.target.nodeName=="INPUT" || e.target.parentNode.className =="guide-bar"){
			errorDialog.style.display = "none";
		}
		//刷新验证码
		if(e.target.className=="phone-code-img" || e.target.className =="phone-code-refresh"){
			phoneInputCode.value = "";
			phoneCodeValue = "";
			getCode(phoneCodeImg);
		}
		if(e.target.className=="email-code-img" || e.target.className =="email-code-refresh"){
			emailCodeValue = "";
			emailInputCode.value = "";
			getCode(emailCodeImg);
		}
	}); 



	//操作证件选择
	var phoneId = common.getClass("phone-id"),//手机找回区的证件按钮
	emailId = common.getClass("email-id");//邮箱找回区的证件按钮
	phoneId.addEventListener("change",function(e){
		var index = e.target.selectedIndex;
		var	options = e.target.options;
		phoneIdcardType = options[index].value;
	});
	emailId.addEventListener("change",function(e){
		var index = e.target.selectedIndex;
		var	options = e.target.options;
		emailIdcardType = options[index].value;
	});
	

	//检验验证码
	var guideBar = common.getClass("guide-bar");
	// phoneInputCode.addEventListener("focus",function(){

	// 	guideBar.style.display = "none";
	// });
	// phoneInputCode.addEventListener("blur",function(){
	// 	guideBar.style.display = "block";
	// });
	phoneInputCode.addEventListener("keyup",function(e){
		errorDialog.style.display = "none";
		var value = e.target.value;
		
		if(value.length == 4){
			phoneCodeValue = value;
			phoneInputCode.value = phoneCodeValue;	
			
		}
		if(value.length>4){
			//console.log("keycode--" +e.keyCode)
			phoneInputCode.value = phoneCodeValue;
		}
	});
	// emailInputCode.addEventListener("focus",function(){
	// 	guideBar.style.display = "none";
	// });
	// emailInputCode.addEventListener("blur",function(){
	// 	guideBar.style.display = "block";
	// });
	emailInputCode.addEventListener("keyup",function(e){
		errorDialog.style.display = "none";
		var value = e.target.value;
		if(value.length==4){
			emailCodeValue = value;
			emailInputCode.value = emailCodeValue;
		}
		if(value.length>4){
			emailInputCode.value = emailCodeValue;
		}
		
	})



	//操作提交处理
	phoneAccount = common.getClass("phone-account"),//手机资料填写区
	phoneCodeWrap = common.getClass("phone-code-wrap");//手机短信验证码区
	//var phoneCodeNumber = common.getClass("phone-code-number"),//手机短信手机号区
	//phonePasswordWrap = common.getClass("phone-password-wrap"),//手机密码重置区
	var phoneSuccess = common.getClass("phone-success"),//手机更改成功
	emailConfirmWrap = common.getClass("email-confirm-wrap"),//邮件提示区
	emailConfirmTip = common.getClass("email-confirm-tip"),//邮件提示信息
	emailConfirmAddress = common.getClass("email-confirm-a");//邮件提示地址
	//初始化回退操作
	handleBack(0);
	
	submitArea.addEventListener("click",function(e){
		var target = e.target.id;
		//console.log(target);
		var wrong = ""
		if(target == "account"){
			phoneValue = phoneNumber.value,
			phoneIdcardValue = phoneIdNumber.value;
			if(!common.testPhoneNum(phoneValue)){
				wrong = "请输入有效手机号";
				showError(wrong,errorDialog);
				return;
			}
			if(phoneIdcardType=="1"&&!common.testIdCard(phoneIdcardValue)){
				wrong = "请输入有效证件号";
				showError(wrong,errorDialog);
				return;
			}
			if(phoneCodeValue.length  != 4){
				wrong = "请输入4位验证码";
				showError(wrong,errorDialog);
				return;
			}
			NativeAPI.invokeProgressDialog("请稍候");
			invoke("forget_password_mobileCode",{mobile:phoneValue,method:'resetPassword',id_no:phoneIdcardValue,id_type:phoneIdcardType,code:phoneCodeValue},function(error,res){
				NativeAPI.invokeProgressDialogDismiss();
				if(error){
					showError(error,errorDialog);
					phoneInputCode.value = "";
					phoneCodeValue = "";
					getCode(phoneCodeImg);
					return;
				}
				handleBack(1,phoneAccount,phoneCodeWrap);
				handleBackTag = 1;
				submitButton.id = "password";//设置提交按钮
				phoneButtonValue = submitButton.id;
				phoneAccount.style.display = "none";
				phoneCodeWrap.style.display = "block";
				phoneCodeTimer.innerHTML = PHONE_GLOBAL.TIME_COUNT;
				// var temp = phoneValue.split("");
				// temp[3] = "*",temp[4] = "*", temp[5] = "*", temp[6] = "*";
				// phoneCodeNumber.value = temp.join("");
				PHONE_GLOBAL.CODE_TIMER = setInterval(timer,1000);

			});
			

			
		// }else if(target == "phoneCode"){
		// 	var phoneMessageValue = phoneMessage.value;
		// 	invoke("jsCheckMobileCode",{id_no:phoneIdcardValue,id_type_code:phoneIdcardType,mobile:phoneValue,randCode:phoneMessageValue},function(error,data){
		// 		if(error){
		// 			showError(error,errorDialog);
		// 			return;
		// 		}
		// 		handleBack(0);
		// 		handleBackTag = 0;
		// 		//console.log(data);
		// 		submitButton.id = "password";//设置提交按钮
		// 		phoneButtonValue = submitButton.id;
		// 		phoneCodeWrap.style.display = "none";
		// 		phonePasswordWrap.style.display = "block";
		// 	});
			
		}else if(target == "password"){
			var phoneMessageValue = phoneMessage.value;
			var password1 = common.getClass("phone-password-pwd1").value;
			var password2 = common.getClass("phone-password-pwd2").value;
			//console.log(password1 +"++++"+ password2);
			//console.log(password1.length);
			if(!phoneMessageValue){
				wrong = "请输入验证码";
				showError(wrong,errorDialog);
				return;
			}
			if(!password1||!password2){
				wrong = "密码不能为空";
				showError(wrong,errorDialog);
				return;
			}
			if(password1.length<6){
				wrong = "密码不能少于六位";
				showError(wrong,errorDialog);
				return;
			}
			if(password1 != password2){
				wrong = "两次密码不一致，请重新输入";
				showError(wrong,errorDialog);
				return;
			}
			NativeAPI.invokeProgressDialog("请稍候");
			invoke("forget_password_resetPassword",{method:"mobile",id_no:phoneIdcardValue,id_type:phoneIdcardType,
				code: phoneMessageValue,mobile:phoneValue,password:password2},function(error,data){
				NativeAPI.invokeProgressDialogDismiss();
				if(error){
					showError(error,errorDialog);
					return;
				}
				handleBack(0);
		 		handleBackTag = 0;
				phoneSuccess.style.display = "block";
			});

			
		}else if(target=="email"){
			emailValue= emailNumber.value,
			emailIdcardValue = emailIdNumber.value;
			if(!common.testEmail(emailValue)){
				wrong = "请输入有效邮箱号";
				showError(wrong,errorDialog);
				return;
			}
			if(emailIdcardType=="1"&&!common.testIdCard(emailIdcardValue)){
				wrong = "请输入有效证件号";
				showError(wrong,errorDialog);
				return;
			}
			NativeAPI.invokeProgressDialog("请稍候");
			invoke("forget_password_resetPassword",{method:"email",id_no:emailIdcardValue,id_type:emailIdcardType,email:emailValue,
				code: emailCodeValue},function(error,data){
				NativeAPI.invokeProgressDialogDismiss();
				if(error){
					showError(error,errorDialog);
					return;
				}
				var a = emailValue.split("@");
				emailConfirmWrap.style.display = "block";
				var link = "http://www.mail." + a[1];
				//console.log("emailConfirm----"+link);
				emailConfirmAddress.href = link;
				emailConfirmAddress.innerHTML = emailValue;
			});
		}


	});

	var emailConfirmButton = common.getClass("email-confirm-button");
	emailConfirmButton.addEventListener("click",function(){
		emailConfirmWrap.style.display = "none";

	});



}